diff -uNr djbdns-1.05/dnscache.c djbdns-1.05-new/dnscache.c
--- djbdns-1.05/dnscache.c	2001-02-11 16:11:45.000000000 -0500
+++ djbdns-1.05-new/dnscache.c	2003-09-16 10:14:51.000000000 -0400
@@ -5,6 +5,7 @@
 #include "strerr.h"
 #include "error.h"
 #include "ip4.h"
+#include "ip6.h"
 #include "uint16.h"
 #include "uint64.h"
 #include "socket.h"
@@ -23,6 +24,10 @@
 #include "okclient.h"
 #include "droproot.h"
 
+char ignoreip[4];
+
+long interface;
+
 static int packetquery(char *buf,unsigned int len,char **q,char qtype[2],char qclass[2],char id[2])
 {
   unsigned int pos;
@@ -46,8 +51,8 @@
 }
 
 
-static char myipoutgoing[4];
-static char myipincoming[4];
+static char myipoutgoing[16];
+static char myipincoming[16];
 static char buf[1024];
 uint64 numqueries = 0;
 
@@ -60,9 +65,10 @@
   struct taia start;
   uint64 active; /* query number, if active; otherwise 0 */
   iopause_fd *io;
-  char ip[4];
+  char ip[16];
   uint16 port;
   char id[2];
+  uint32 scope_id;
 } u[MAXUDP];
 int uactive = 0;
 
@@ -78,7 +84,7 @@
   if (!u[j].active) return;
   response_id(u[j].id);
   if (response_len > 512) response_tc();
-  socket_send4(udp53,response,response_len,u[j].ip,u[j].port);
+  socket_send6(udp53,response,response_len,u[j].ip,u[j].port,u[j].scope_id);
   log_querydone(&u[j].active,response_len);
   u[j].active = 0; --uactive;
 }
@@ -109,7 +115,7 @@
   x = u + j;
   taia_now(&x->start);
 
-  len = socket_recv4(udp53,buf,sizeof buf,x->ip,&x->port);
+  len = socket_recv6(udp53,buf,sizeof buf,x->ip,&x->port,&x->scope_id);
   if (len == -1) return;
   if (len >= sizeof buf) return;
   if (x->port < 1024) if (x->port != 53) return;
@@ -119,7 +125,7 @@
 
   x->active = ++numqueries; ++uactive;
   log_query(&x->active,x->ip,x->port,x->id,q,qtype);
-  switch(query_start(&x->q,q,qtype,qclass,myipoutgoing)) {
+  switch(query_start(&x->q,q,qtype,qclass,myipoutgoing,interface)) {
     case -1:
       u_drop(j);
       return;
@@ -128,7 +134,6 @@
   }
 }
 
-
 static int tcp53;
 
 #define MAXTCP 20
@@ -138,7 +143,7 @@
   struct taia timeout;
   uint64 active; /* query number or 1, if active; otherwise 0 */
   iopause_fd *io;
-  char ip[4]; /* send response to this address */
+  char ip[16]; /* send response to this address */
   uint16 port; /* send response to this port */
   char id[2];
   int tcp; /* open TCP socket, if active */
@@ -146,6 +151,7 @@
   char *buf; /* 0, or dynamically allocated of length len */
   unsigned int len;
   unsigned int pos;
+  uint32 scope_id;
 } t[MAXTCP];
 int tactive = 0;
 
@@ -254,7 +260,7 @@
 
   x->active = ++numqueries;
   log_query(&x->active,x->ip,x->port,x->id,q,qtype);
-  switch(query_start(&x->q,q,qtype,qclass,myipoutgoing)) {
+  switch(query_start(&x->q,q,qtype,qclass,myipoutgoing,interface)) {
     case -1:
       t_drop(j);
       return;
@@ -291,7 +297,7 @@
   x = t + j;
   taia_now(&x->start);
 
-  x->tcp = socket_accept4(tcp53,x->ip,&x->port);
+  x->tcp = socket_accept6(tcp53,x->ip,&x->port,&x->scope_id);
   if (x->tcp == -1) return;
   if (x->port < 1024) if (x->port != 53) { close(x->tcp); return; }
   if (!okclient(x->ip)) { close(x->tcp); return; }
@@ -391,22 +397,32 @@
   char *x;
   unsigned long cachesize;
 
+  x = env_get("INTERFACE");
+  if (x) scan_ulong(x,&interface);
+
   x = env_get("IP");
   if (!x)
     strerr_die2x(111,FATAL,"$IP not set");
-  if (!ip4_scan(x,myipincoming))
+  if (!ip6_scan(x,myipincoming))
     strerr_die3x(111,FATAL,"unable to parse IP address ",x);
 
-  udp53 = socket_udp();
+#if 0
+  /* if if IP is a mapped-IPv4 address, disable IPv6 functionality */
+  /* this is actually a bad idea */
+  if (ip6_isv4mapped(myipincoming))
+    noipv6 = 1;
+#endif
+
+  udp53 = socket_udp6();
   if (udp53 == -1)
     strerr_die2sys(111,FATAL,"unable to create UDP socket: ");
-  if (socket_bind4_reuse(udp53,myipincoming,53) == -1)
+  if (socket_bind6_reuse(udp53,myipincoming,53,interface) == -1)
     strerr_die2sys(111,FATAL,"unable to bind UDP socket: ");
 
-  tcp53 = socket_tcp();
+  tcp53 = socket_tcp6();
   if (tcp53 == -1)
     strerr_die2sys(111,FATAL,"unable to create TCP socket: ");
-  if (socket_bind4_reuse(tcp53,myipincoming,53) == -1)
+  if (socket_bind6_reuse(tcp53,myipincoming,53,interface) == -1)
     strerr_die2sys(111,FATAL,"unable to bind TCP socket: ");
 
   droproot(FATAL);
@@ -421,7 +437,7 @@
   x = env_get("IPSEND");
   if (!x)
     strerr_die2x(111,FATAL,"$IPSEND not set");
-  if (!ip4_scan(x,myipoutgoing))
+  if (!ip6_scan(x,myipoutgoing))
     strerr_die3x(111,FATAL,"unable to parse IP address ",x);
 
   x = env_get("CACHESIZE");
@@ -431,10 +447,18 @@
   if (!cache_init(cachesize))
     strerr_die3x(111,FATAL,"not enough memory for cache of size ",x);
 
+  /* VeriSign Patch */
+  x = env_get("IGNOREIP");
+  if (x)
+    if (!ip4_scan(x,ignoreip))
+	    strerr_die3x(111,FATAL,"unable to parse IGNOREIP address ",x);
+
   if (env_get("HIDETTL"))
     response_hidettl();
-  if (env_get("FORWARDONLY"))
-    query_forwardonly();
+  if (env_get("FORWARDONLY")) {
+    roots_forwardonly();
+    log_forwardonly_deprecated();
+  }
 
   if (!roots_init())
     strerr_die2sys(111,FATAL,"unable to read servers: ");
diff -uNr djbdns-1.05/dnsfilter.c djbdns-1.05-new/dnsfilter.c
--- djbdns-1.05/dnsfilter.c	2001-02-11 16:11:45.000000000 -0500
+++ djbdns-1.05-new/dnsfilter.c	2003-09-16 10:09:36.000000000 -0400
@@ -12,6 +12,7 @@
 #include "iopause.h"
 #include "error.h"
 #include "exit.h"
+#include "ip6.h"
 
 #define FATAL "dnsfilter: fatal: "
 
@@ -44,7 +45,7 @@
 iopause_fd *io;
 int iolen;
 
-char servers[64];
+char servers[256];
 char ip[4];
 char name[DNS_NAME4_DOMAIN];
 
@@ -191,7 +192,7 @@
 	      dns_name4_domain(name,ip);
 	      if (dns_resolvconfip(servers) == -1)
 	        strerr_die2sys(111,FATAL,"unable to read /etc/resolv.conf: ");
-	      if (dns_transmit_start(&x[xnum].dt,servers,1,name,DNS_T_PTR,"\0\0\0\0") == -1)
+	      if (dns_transmit_start(&x[xnum].dt,servers,1,name,DNS_T_PTR,V6any) == -1)
 	        errout(xnum);
 	      else {
 	        x[xnum].flagactive = 1;
diff -uNr djbdns-1.05/dnsip6.c djbdns-1.05-new/dnsip6.c
--- djbdns-1.05/dnsip6.c	1969-12-31 19:00:00.000000000 -0500
+++ djbdns-1.05-new/dnsip6.c	2003-09-16 10:09:36.000000000 -0400
@@ -0,0 +1,40 @@
+#include "buffer.h"
+#include "exit.h"
+#include "strerr.h"
+#include "ip6.h"
+#include "dns.h"
+
+#define FATAL "dnsip: fatal: "
+
+static char seed[128];
+
+static stralloc fqdn;
+static stralloc out;
+char str[IP6_FMT];
+
+main(int argc,char **argv)
+{
+  int i;
+
+  dns_random_init(seed);
+
+  if (*argv) ++argv;
+
+  while (*argv) {
+    if (!stralloc_copys(&fqdn,*argv))
+      strerr_die2x(111,FATAL,"out of memory");
+    if (dns_ip6(&out,&fqdn) == -1)
+      strerr_die4sys(111,FATAL,"unable to find IPv6 address for ",*argv,": ");
+
+    for (i = 0;i + 16 <= out.len;i += 16) {
+      buffer_put(buffer_1,str,ip6_fmt(str,out.s + i));
+      buffer_puts(buffer_1," ");
+    }
+    buffer_puts(buffer_1,"\n");
+
+    ++argv;
+  }
+
+  buffer_flush(buffer_1);
+  _exit(0);
+}
diff -uNr djbdns-1.05/dnsip6q.c djbdns-1.05-new/dnsip6q.c
--- djbdns-1.05/dnsip6q.c	1969-12-31 19:00:00.000000000 -0500
+++ djbdns-1.05-new/dnsip6q.c	2003-09-16 10:09:36.000000000 -0400
@@ -0,0 +1,43 @@
+#include "buffer.h"
+#include "exit.h"
+#include "strerr.h"
+#include "ip6.h"
+#include "dns.h"
+
+#define FATAL "dnsipq: fatal: "
+
+static char seed[128];
+
+static stralloc in;
+static stralloc fqdn;
+static stralloc out;
+char str[IP6_FMT];
+
+int main(int argc,char **argv)
+{
+  int i;
+
+  dns_random_init(seed);
+
+  if (*argv) ++argv;
+
+  while (*argv) {
+    if (!stralloc_copys(&in,*argv))
+      strerr_die2x(111,FATAL,"out of memory");
+    if (dns_ip6_qualify(&out,&fqdn,&in) == -1)
+      strerr_die4sys(111,FATAL,"unable to find IP6 address for ",*argv,": ");
+
+    buffer_put(buffer_1,fqdn.s,fqdn.len);
+    buffer_puts(buffer_1," ");
+    for (i = 0;i + 16 <= out.len;i += 16) {
+      buffer_put(buffer_1,str,ip6_fmt(str,out.s + i));
+      buffer_puts(buffer_1," ");
+    }
+    buffer_puts(buffer_1,"\n");
+
+    ++argv;
+  }
+
+  buffer_flush(buffer_1);
+  _exit(0);
+}
diff -uNr djbdns-1.05/dnsname.c djbdns-1.05-new/dnsname.c
--- djbdns-1.05/dnsname.c	2001-02-11 16:11:45.000000000 -0500
+++ djbdns-1.05-new/dnsname.c	2003-09-16 10:09:36.000000000 -0400
@@ -9,6 +9,7 @@
 static char seed[128];
 
 char ip[4];
+char ip6[16];
 static stralloc out;
 
 int main(int argc,char **argv)
@@ -18,10 +19,15 @@
   if (*argv) ++argv;
 
   while (*argv) {
-    if (!ip4_scan(*argv,ip))
-      strerr_die3x(111,FATAL,"unable to parse IP address ",*argv);
-    if (dns_name4(&out,ip) == -1)
-      strerr_die4sys(111,FATAL,"unable to find host name for ",*argv,": ");
+    if (ip6_scan(*argv,ip6)) {
+      if (dns_name6(&out,ip6) == -1)
+	strerr_die4sys(111,FATAL,"unable to find host name for ",*argv,": ");
+    } else {
+      if (!ip4_scan(*argv,ip))
+	strerr_die3x(111,FATAL,"unable to parse IP address ",*argv);
+      if (dns_name4(&out,ip) == -1)
+	strerr_die4sys(111,FATAL,"unable to find host name for ",*argv,": ");
+    }
 
     buffer_put(buffer_1,out.s,out.len);
     buffer_puts(buffer_1,"\n");
diff -uNr djbdns-1.05/dnsq.c djbdns-1.05-new/dnsq.c
--- djbdns-1.05/dnsq.c	2001-02-11 16:11:45.000000000 -0500
+++ djbdns-1.05-new/dnsq.c	2003-09-16 10:09:36.000000000 -0400
@@ -10,6 +10,7 @@
 #include "printpacket.h"
 #include "parsetype.h"
 #include "dns.h"
+#include "ip6.h"
 
 #define FATAL "dnsq: fatal: "
 
@@ -24,14 +25,14 @@
 
 static struct dns_transmit tx;
 
-int resolve(char *q,char qtype[2],char servers[64])
+int resolve(char *q,char qtype[2],char servers[256])
 {
   struct taia stamp;
   struct taia deadline;
   iopause_fd x[1];
   int r;
 
-  if (dns_transmit_start(&tx,servers,0,q,qtype,"\0\0\0\0") == -1) return -1;
+  if (dns_transmit_start(&tx,servers,0,q,qtype,V6any) == -1) return -1;
 
   for (;;) {
     taia_now(&stamp);
@@ -47,7 +48,7 @@
   return 0;
 }
 
-char servers[64];
+char servers[256];
 static stralloc ip;
 static stralloc fqdn;
 
@@ -73,9 +74,9 @@
 
   if (!*++argv) usage();
   if (!stralloc_copys(&out,*argv)) oops();
-  if (dns_ip4_qualify(&ip,&fqdn,&out) == -1) oops();
-  if (ip.len >= 64) ip.len = 64;
-  byte_zero(servers,64);
+  if (dns_ip6_qualify(&ip,&fqdn,&out) == -1) oops();
+  if (ip.len >= 256) ip.len = 256;
+  byte_zero(servers,256);
   byte_copy(servers,ip.len,ip.s);
 
   if (!stralloc_copys(&out,"")) oops();
diff -uNr djbdns-1.05/dnstrace.c djbdns-1.05-new/dnstrace.c
--- djbdns-1.05/dnstrace.c	2001-02-11 16:11:45.000000000 -0500
+++ djbdns-1.05-new/dnstrace.c	2003-09-16 10:09:36.000000000 -0400
@@ -4,6 +4,7 @@
 #include "str.h"
 #include "byte.h"
 #include "ip4.h"
+#include "ip6.h"
 #include "gen_alloc.h"
 #include "gen_allocdefs.h"
 #include "exit.h"
@@ -30,7 +31,7 @@
 }
 
 static stralloc querystr;
-char ipstr[IP4_FMT];
+char ipstr[IP6_FMT];
 static stralloc tmp;
 
 void printdomain(const char *d)
@@ -42,19 +43,19 @@
 
 static struct dns_transmit tx;
 
-int resolve(char *q,char qtype[2],char ip[4])
+int resolve(char *q,char qtype[2],char ip[16])
 {
   struct taia start;
   struct taia stamp;
   struct taia deadline;
-  char servers[64];
+  char servers[256];
   iopause_fd x[1];
   int r;
 
   taia_now(&start);
 
-  byte_zero(servers,64);
-  byte_copy(servers,4,ip);
+  byte_zero(servers,256);
+  byte_copy(servers,16,ip);
 
   if (dns_transmit_start(&tx,servers,0,q,qtype,"\0\0\0\0") == -1) return -1;
 
@@ -82,7 +83,7 @@
 
 struct address {
   char *owner;
-  char ip[4];
+  char ip[16];
 } ;
 
 GEN_ALLOC_typedef(address_alloc,struct address,s,len,a)
@@ -117,7 +118,7 @@
   char *owner;
   char type[2];
   char *control;
-  char ip[4];
+  char ip[16];
 } ;
 
 GEN_ALLOC_typedef(qt_alloc,struct qt,s,len,a)
@@ -126,7 +127,7 @@
 
 static qt_alloc qt;
 
-void qt_add(const char *q,const char type[2],const char *control,const char ip[4])
+void qt_add(const char *q,const char type[2],const char *control,const char ip[16])
 {
   struct qt x;
   int i;
@@ -137,14 +138,14 @@
     if (dns_domain_equal(qt.s[i].owner,q))
       if (dns_domain_equal(qt.s[i].control,control))
         if (byte_equal(qt.s[i].type,2,type))
-	  if (byte_equal(qt.s[i].ip,4,ip))
+	  if (byte_equal(qt.s[i].ip,16,ip))
 	    return;
 
   byte_zero(&x,sizeof x);
   if (!dns_domain_copy(&x.owner,q)) nomem();
   if (!dns_domain_copy(&x.control,control)) nomem();
   byte_copy(x.type,2,type);
-  byte_copy(x.ip,4,ip);
+  byte_copy(x.ip,16,ip);
   if (!qt_alloc_append(&qt,&x)) nomem();
 }
 
@@ -203,7 +204,7 @@
 	  qt_add(query.s[i].owner,query.s[i].type,owner,address.s[j].ip);
 }
 
-void address_add(const char *owner,const char ip[4])
+void address_add(const char *owner,const char ip[16])
 {
   struct address x;
   int i;
@@ -213,17 +214,20 @@
   buffer_puts(buffer_1,"A:");
   printdomain(owner);
   buffer_puts(buffer_1,":");
-  buffer_put(buffer_1,ipstr,ip4_fmt(ipstr,ip));
+  if (ip6_isv4mapped(ip))
+    buffer_put(buffer_1,ipstr,ip4_fmt(ipstr,ip+12));
+  else
+    buffer_put(buffer_1,ipstr,ip6_fmt(ipstr,ip));
   buffer_puts(buffer_1,"\n");
 
   for (i = 0;i < address.len;++i)
     if (dns_domain_equal(address.s[i].owner,owner))
-      if (byte_equal(address.s[i].ip,4,ip))
+      if (byte_equal(address.s[i].ip,16,ip))
 	return;
 
   byte_zero(&x,sizeof x);
   if (!dns_domain_copy(&x.owner,owner)) nomem();
-  byte_copy(x.ip,4,ip);
+  byte_copy(x.ip,16,ip);
   if (!address_alloc_append(&address,&x)) nomem();
 
   for (i = 0;i < ns.len;++i)
@@ -331,7 +335,12 @@
 	  ns_add(t1,t2);
         }
         else if (typematch(header,DNS_T_A) && datalen == 4) {
-	  if (!dns_packet_copy(buf,len,pos,misc,4)) goto DIE;
+	  if (!dns_packet_copy(buf,len,pos,misc+12,4)) goto DIE;
+	  byte_copy(misc,12,V4mappedprefix);
+	  address_add(t1,misc);
+        }
+        else if (typematch(header,DNS_T_AAAA) && datalen == 16) {
+	  if (!dns_packet_copy(buf,len,pos,misc,16)) goto DIE;
 	  address_add(t1,misc);
         }
       }
@@ -419,8 +428,8 @@
 
   while (*++argv) {
     if (!stralloc_copys(&udn,*argv)) nomem();
-    if (dns_ip4_qualify(&out,&fqdn,&udn) == -1) nomem(); /* XXX */
-    for (i = 0;i + 4 <= out.len;i += 4)
+    if (dns_ip6_qualify(&out,&fqdn,&udn) == -1) nomem(); /* XXX */
+    for (i = 0;i + 16 <= out.len;i += 16)
       address_add("",out.s + i);
   }
 
@@ -429,7 +438,7 @@
     control = qt.s[i].control;
     if (!dns_domain_suffix(q,control)) continue;
     byte_copy(type,2,qt.s[i].type);
-    byte_copy(ip,4,qt.s[i].ip);
+    byte_copy(ip,16,qt.s[i].ip);
 
     if (!stralloc_copys(&querystr,"")) nomem();
     uint16_unpack_big(type,&u16);
@@ -439,7 +448,10 @@
     if (!stralloc_cats(&querystr,":")) nomem();
     if (!dns_domain_todot_cat(&querystr,control)) nomem();
     if (!stralloc_cats(&querystr,":")) nomem();
-    if (!stralloc_catb(&querystr,ipstr,ip4_fmt(ipstr,ip))) nomem();
+    if (ip6_isv4mapped(ip)) {
+      if (!stralloc_catb(&querystr,ipstr,ip4_fmt(ipstr,ip+12))) nomem();
+    } else
+      if (!stralloc_catb(&querystr,ipstr,ip6_fmt(ipstr,ip))) nomem();
     if (!stralloc_cats(&querystr,":")) nomem();
 
     buffer_put(buffer_1,querystr.s,querystr.len);
diff -uNr djbdns-1.05/fmt_xlong.c djbdns-1.05-new/fmt_xlong.c
--- djbdns-1.05/fmt_xlong.c	1969-12-31 19:00:00.000000000 -0500
+++ djbdns-1.05-new/fmt_xlong.c	2003-09-16 10:09:36.000000000 -0400
@@ -0,0 +1,22 @@
+#include "fmt.h"
+
+char tohex(char num) {
+  if (num<10)
+    return num+'0';
+  else if (num<16)
+    return num-10+'a';
+  else
+    return -1;
+}
+
+unsigned int fmt_xlong(register char *s,register unsigned long u)
+{
+  register unsigned int len; register unsigned long q;
+  len = 1; q = u;
+  while (q > 15) { ++len; q /= 16; }
+  if (s) {
+    s += len;
+    do { *--s = tohex(u % 16); u /= 16; } while(u); /* handles u == 0 */
+  }
+  return len;
+}
diff -uNr djbdns-1.05/haveip6.h1 djbdns-1.05-new/haveip6.h1
--- djbdns-1.05/haveip6.h1	1969-12-31 19:00:00.000000000 -0500
+++ djbdns-1.05-new/haveip6.h1	2003-09-16 10:09:36.000000000 -0400
@@ -0,0 +1 @@
+
diff -uNr djbdns-1.05/haveip6.h2 djbdns-1.05-new/haveip6.h2
--- djbdns-1.05/haveip6.h2	1969-12-31 19:00:00.000000000 -0500
+++ djbdns-1.05-new/haveip6.h2	2003-09-16 10:09:36.000000000 -0400
@@ -0,0 +1 @@
+#define LIBC_HAS_IP6 1
diff -uNr djbdns-1.05/haven2i.h1 djbdns-1.05-new/haven2i.h1
--- djbdns-1.05/haven2i.h1	1969-12-31 19:00:00.000000000 -0500
+++ djbdns-1.05-new/haven2i.h1	2003-09-16 10:09:36.000000000 -0400
@@ -0,0 +1 @@
+#undef HAVE_N2I
diff -uNr djbdns-1.05/haven2i.h2 djbdns-1.05-new/haven2i.h2
--- djbdns-1.05/haven2i.h2	1969-12-31 19:00:00.000000000 -0500
+++ djbdns-1.05-new/haven2i.h2	2003-09-16 10:09:36.000000000 -0400
@@ -0,0 +1 @@
+#define HAVE_N2I
diff -uNr djbdns-1.05/hier.c djbdns-1.05-new/hier.c
--- djbdns-1.05/hier.c	2001-02-11 16:11:45.000000000 -0500
+++ djbdns-1.05-new/hier.c	2003-09-16 10:09:36.000000000 -0400
@@ -29,7 +29,9 @@
   c(auto_home,"bin","axfr-get",-1,-1,0755);
 
   c(auto_home,"bin","dnsip",-1,-1,0755);
+  c(auto_home,"bin","dnsip6",-1,-1,0755);
   c(auto_home,"bin","dnsipq",-1,-1,0755);
+  c(auto_home,"bin","dnsip6q",-1,-1,0755);
   c(auto_home,"bin","dnsname",-1,-1,0755);
   c(auto_home,"bin","dnstxt",-1,-1,0755);
   c(auto_home,"bin","dnsmx",-1,-1,0755);
diff -uNr djbdns-1.05/ip6.h djbdns-1.05-new/ip6.h
--- djbdns-1.05/ip6.h	1969-12-31 19:00:00.000000000 -0500
+++ djbdns-1.05-new/ip6.h	2003-09-16 10:09:36.000000000 -0400
@@ -0,0 +1,28 @@
+#ifndef IP6_H
+#define IP6_H
+
+extern unsigned int ip6_scan(const char *,char *);
+extern unsigned int ip6_fmt(char *,const char *);
+
+extern unsigned int ip6_scan_flat(const char *,char *);
+extern unsigned int ip6_fmt_flat(char *,char *);
+
+/*
+ ip6 address syntax: (h = hex digit), no leading '0' required
+   1. hhhh:hhhh:hhhh:hhhh:hhhh:hhhh:hhhh:hhhh
+   2. any number of 0000 may be abbreviated as "::", but only once
+ flat ip6 address syntax:
+   hhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhh
+ */
+
+#define IP6_FMT 40
+
+const static unsigned char V4mappedprefix[12]={0,0,0,0,0,0,0,0,0,0,0xff,0xff};
+const static unsigned char V6loopback[16]={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1};
+const static unsigned char V6any[16]={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
+
+#define ip6_isv4mapped(ip) (byte_equal(ip,12,V4mappedprefix))
+
+const static char ip4loopback[4] = {127,0,0,1};
+
+#endif
diff -uNr djbdns-1.05/ip6_fmt.c djbdns-1.05-new/ip6_fmt.c
--- djbdns-1.05/ip6_fmt.c	1969-12-31 19:00:00.000000000 -0500
+++ djbdns-1.05-new/ip6_fmt.c	2003-09-16 10:09:36.000000000 -0400
@@ -0,0 +1,66 @@
+#include "fmt.h"
+#include "byte.h"
+#include "ip4.h"
+#include "ip6.h"
+#include <stdio.h>
+
+unsigned int ip6_fmt(char *s,const char ip[16])
+{
+  unsigned int len;
+  unsigned int i;
+  unsigned int temp;
+  unsigned int compressing;
+  int j;
+
+  len = 0; compressing = 0;
+  for (j=0; j<16; j+=2) {
+    if (j==12 && ip6_isv4mapped(ip)) {
+      temp=ip4_fmt(s,ip+12);
+      len+=temp;
+      break;
+    }
+    temp = ((unsigned long) (unsigned char) ip[j] << 8) +
+            (unsigned long) (unsigned char) ip[j+1];
+    if (temp == 0) {
+      if (!compressing) {
+	compressing=1;
+	if (j==0) {
+	  if (s) *s++=':'; ++len;
+	}
+      }
+    } else {
+      if (compressing) {
+	compressing=0;
+	if (s) *s++=':'; ++len;
+      }
+      i = fmt_xlong(s,temp); len += i; if (s) s += i;
+      if (j<14) {
+	if (s) *s++ = ':';
+	++len;
+      }
+    }
+  }
+  if (compressing) { *s++=':'; ++len; }
+
+/*  if (s) *s=0; */
+  return len;
+}
+
+static char tohex(char num) {
+  if (num<10)
+    return num+'0';
+  else if (num<16)
+    return num-10+'a';
+  else
+    return -1;
+}
+
+unsigned int ip6_fmt_flat(char *s,char ip[16])
+{
+  int i;
+  for (i=0; i<16; i++) {
+    *s++=tohex((unsigned char)ip[i] >> 4);
+    *s++=tohex((unsigned char)ip[i] & 15);
+  }
+  return 32;
+}
diff -uNr djbdns-1.05/ip6_scan.c djbdns-1.05-new/ip6_scan.c
--- djbdns-1.05/ip6_scan.c	1969-12-31 19:00:00.000000000 -0500
+++ djbdns-1.05-new/ip6_scan.c	2003-09-16 10:09:36.000000000 -0400
@@ -0,0 +1,115 @@
+#include "scan.h"
+#include "ip4.h"
+#include "ip6.h"
+#include "byte.h"
+
+/*
+ * IPv6 addresses are really ugly to parse.
+ * Syntax: (h = hex digit)
+ *   1. hhhh:hhhh:hhhh:hhhh:hhhh:hhhh:hhhh:hhhh
+ *   2. any number of 0000 may be abbreviated as "::", but only once
+ *   3. The last two words may be written as IPv4 address
+ */
+
+unsigned int ip6_scan(const char *s,char ip[16])
+{
+  unsigned int i;
+  unsigned int len=0;
+  unsigned long u;
+
+  char suffix[16];
+  int prefixlen=0;
+  int suffixlen=0;
+
+  if ((i=ip4_scan(s,ip+12))) {
+    const char *c=V4mappedprefix;
+    if (byte_equal(ip+12,4,V6any)) c=V6any;
+    for (len=0; len<12; ++len) ip[len]=c[len];
+    return i;
+  }
+  for (i=0; i<16; i++) ip[i]=0;
+  for (;;) {
+    if (*s == ':') {
+      len++;
+      if (s[1] == ':') {	/* Found "::", skip to part 2 */
+	s+=2;
+	len++;
+	break;
+      }
+      s++;
+    }
+    i = scan_xlong(s,&u);
+    if (!i) return 0;
+    if (prefixlen==12 && s[i]=='.') {
+      /* the last 4 bytes may be written as IPv4 address */
+      i=ip4_scan(s,ip+12);
+      if (i)
+	return i+len;
+      else
+	return 0;
+    }
+    ip[prefixlen++] = (u >> 8);
+    ip[prefixlen++] = (u & 255);
+    s += i; len += i;
+    if (prefixlen==16)
+      return len;
+  }
+
+/* part 2, after "::" */
+  for (;;) {
+    if (*s == ':') {
+      if (suffixlen==0)
+	break;
+      s++;
+      len++;
+    } else if (suffixlen!=0)
+      break;
+    i = scan_xlong(s,&u);
+    if (!i) {
+      len--;
+      break;
+    }
+    if (suffixlen+prefixlen<=12 && s[i]=='.') {
+      int j=ip4_scan(s,suffix+suffixlen);
+      if (j) {
+	suffixlen+=4;
+	len+=j;
+	break;
+      } else
+	prefixlen=12-suffixlen;	/* make end-of-loop test true */
+    }
+    suffix[suffixlen++] = (u >> 8);
+    suffix[suffixlen++] = (u & 255);
+    s += i; len += i;
+    if (prefixlen+suffixlen==16)
+      break;
+  }
+  for (i=0; i<suffixlen; i++)
+    ip[16-suffixlen+i] = suffix[i];
+  return len;
+}
+
+static long int fromhex(unsigned char c) {
+  if (c>='0' && c<='9')
+    return c-'0';
+  else if (c>='A' && c<='F')
+    return c-'A'+10;
+  else if (c>='a' && c<='f')
+    return c-'a'+10;
+  return -1;
+}
+
+unsigned int ip6_scan_flat(const char *s,char ip[16])
+{
+  int i;
+  for (i=0; i<16; i++) {
+    int tmp;
+    tmp=fromhex(*s++);
+    if (tmp<0) return 0;
+    ip[i]=tmp << 4;
+    tmp=fromhex(*s++);
+    if (tmp<0) return 0;
+    ip[i]+=tmp;
+  }
+  return 32;
+}
diff -uNr djbdns-1.05/log.c djbdns-1.05-new/log.c
--- djbdns-1.05/log.c	2001-02-11 16:11:45.000000000 -0500
+++ djbdns-1.05-new/log.c	2003-09-16 10:09:36.000000000 -0400
@@ -3,6 +3,7 @@
 #include "uint16.h"
 #include "error.h"
 #include "byte.h"
+#include "ip6.h"
 #include "log.h"
 
 /* work around gcc 2.95.2 bug */
@@ -45,12 +46,10 @@
   string(" ");
 }
 
-static void ip(const char i[4])
+static void ip(const char i[16])
 {
-  hex(i[0]);
-  hex(i[1]);
-  hex(i[2]);
-  hex(i[3]);
+  int j;
+  for (j=0; j<16; ++j) hex(i[j]);
 }
 
 static void logid(const char id[2])
@@ -94,7 +93,13 @@
   line();
 }
 
-void log_query(uint64 *qnum,const char client[4],unsigned int port,const char id[2],const char *q,const char qtype[2])
+void log_forwardonly_deprecated()
+{
+  string("use of FORWARDONLY environment variable deprecated"); line();
+  string("use root/caches/<domain> instead"); line();
+}
+
+void log_query(uint64 *qnum,const char client[16],unsigned int port,const char id[2],const char *q,const char qtype[2])
 {
   string("query "); number(*qnum); space();
   ip(client); string(":"); hex(port >> 8); hex(port & 255);
@@ -119,14 +124,14 @@
   line();
 }
 
-void log_tcpopen(const char client[4],unsigned int port)
+void log_tcpopen(const char client[16],unsigned int port)
 {
   string("tcpopen ");
   ip(client); string(":"); hex(port >> 8); hex(port & 255);
   line();
 }
 
-void log_tcpclose(const char client[4],unsigned int port)
+void log_tcpclose(const char client[16],unsigned int port)
 {
   const char *x = error_str(errno);
   string("tcpclose ");
@@ -135,15 +140,15 @@
   line();
 }
 
-void log_tx(const char *q,const char qtype[2],const char *control,const char servers[64],unsigned int gluelessness)
+void log_tx(const char *q,const char qtype[2],const char *control,const char servers[256],unsigned int gluelessness)
 {
   int i;
 
   string("tx "); number(gluelessness); space();
   logtype(qtype); space(); name(q); space();
   name(control);
-  for (i = 0;i < 64;i += 4)
-    if (byte_diff(servers + i,4,"\0\0\0\0")) {
+  for (i = 0;i < 256;i += 16)
+    if (byte_diff(servers + i,16,V6any)) {
       space();
       ip(servers + i);
     }
@@ -175,21 +180,21 @@
   line();
 }
 
-void log_nxdomain(const char server[4],const char *q,unsigned int ttl)
+void log_nxdomain(const char server[16],const char *q,unsigned int ttl)
 {
   string("nxdomain "); ip(server); space(); number(ttl); space();
   name(q);
   line();
 }
 
-void log_nodata(const char server[4],const char *q,const char qtype[2],unsigned int ttl)
+void log_nodata(const char server[16],const char *q,const char qtype[2],unsigned int ttl)
 {
   string("nodata "); ip(server); space(); number(ttl); space();
   logtype(qtype); space(); name(q);
   line();
 }
 
-void log_lame(const char server[4],const char *control,const char *referral)
+void log_lame(const char server[16],const char *control,const char *referral)
 {
   string("lame "); ip(server); space();
   name(control); space(); name(referral);
@@ -205,7 +210,7 @@
   line();
 }
 
-void log_rr(const char server[4],const char *q,const char type[2],const char *buf,unsigned int len,unsigned int ttl)
+void log_rr(const char server[16],const char *q,const char type[2],const char *buf,unsigned int len,unsigned int ttl)
 {
   int i;
 
@@ -222,7 +227,7 @@
   line();
 }
 
-void log_rrns(const char server[4],const char *q,const char *data,unsigned int ttl)
+void log_rrns(const char server[16],const char *q,const char *data,unsigned int ttl)
 {
   string("rr "); ip(server); space(); number(ttl);
   string(" ns "); name(q); space();
@@ -230,7 +235,7 @@
   line();
 }
 
-void log_rrcname(const char server[4],const char *q,const char *data,unsigned int ttl)
+void log_rrcname(const char server[16],const char *q,const char *data,unsigned int ttl)
 {
   string("rr "); ip(server); space(); number(ttl);
   string(" cname "); name(q); space();
@@ -238,7 +243,7 @@
   line();
 }
 
-void log_rrptr(const char server[4],const char *q,const char *data,unsigned int ttl)
+void log_rrptr(const char server[16],const char *q,const char *data,unsigned int ttl)
 {
   string("rr "); ip(server); space(); number(ttl);
   string(" ptr "); name(q); space();
@@ -246,7 +251,7 @@
   line();
 }
 
-void log_rrmx(const char server[4],const char *q,const char *mx,const char pref[2],unsigned int ttl)
+void log_rrmx(const char server[16],const char *q,const char *mx,const char pref[2],unsigned int ttl)
 {
   uint16 u;
 
@@ -257,7 +262,7 @@
   line();
 }
 
-void log_rrsoa(const char server[4],const char *q,const char *n1,const char *n2,const char misc[20],unsigned int ttl)
+void log_rrsoa(const char server[16],const char *q,const char *n1,const char *n2,const char misc[20],unsigned int ttl)
 {
   uint32 u;
   int i;
diff -uNr djbdns-1.05/log.h djbdns-1.05-new/log.h
--- djbdns-1.05/log.h	2001-02-11 16:11:45.000000000 -0500
+++ djbdns-1.05-new/log.h	2003-09-16 10:09:36.000000000 -0400
@@ -4,6 +4,7 @@
 #include "uint64.h"
 
 extern void log_startup(void);
+extern void log_forwardonly_deprecated(void);
 
 extern void log_query(uint64 *,const char *,unsigned int,const char *,const char *,const char *);
 extern void log_querydrop(uint64 *);
diff -uNr djbdns-1.05/okclient.c djbdns-1.05-new/okclient.c
--- djbdns-1.05/okclient.c	2001-02-11 16:11:45.000000000 -0500
+++ djbdns-1.05-new/okclient.c	2003-09-16 10:09:36.000000000 -0400
@@ -2,24 +2,34 @@
 #include <sys/stat.h>
 #include "str.h"
 #include "ip4.h"
+#include "ip6.h"
+#include "byte.h"
 #include "okclient.h"
 
 static char fn[3 + IP4_FMT];
 
-int okclient(char ip[4])
+int okclient(char ip[16])
 {
   struct stat st;
   int i;
+  char sep;
 
   fn[0] = 'i';
   fn[1] = 'p';
   fn[2] = '/';
-  fn[3 + ip4_fmt(fn + 3,ip)] = 0;
+  if (byte_equal(ip,12,V4mappedprefix)) {
+    fn[3 + ip4_fmt(fn + 3,ip+12)] = 0;
+    sep='.';
+  } else {
+    fn[3 + ip6_fmt(fn + 3,ip)] = 0;
+    sep=':';
+  }
 
   for (;;) {
+    if (!fn[3]) return 0;
     if (stat(fn,&st) == 0) return 1;
     /* treat temporary error as rejection */
-    i = str_rchr(fn,'.');
+    i = str_rchr(fn,sep);
     if (!fn[i]) return 0;
     fn[i] = 0;
   }
diff -uNr djbdns-1.05/printrecord.c djbdns-1.05-new/printrecord.c
--- djbdns-1.05/printrecord.c	2001-02-11 16:11:45.000000000 -0500
+++ djbdns-1.05-new/printrecord.c	2003-09-16 10:09:36.000000000 -0400
@@ -4,6 +4,7 @@
 #include "byte.h"
 #include "dns.h"
 #include "printrecord.h"
+#include "ip6.h"
 
 static char *d;
 
@@ -82,6 +83,15 @@
       if (!stralloc_catulong0(out,ch,0)) return 0;
     }
   }
+  else if (byte_equal(misc,2,DNS_T_AAAA)) {
+    char ip6str[IP6_FMT];
+    int stringlen;
+    if (datalen != 16) { errno = error_proto; return 0; }
+    if (!stralloc_cats(out," AAAA ")) return 0;
+    pos = dns_packet_copy(buf,len,pos,misc,16); if (!pos) return 0;
+    stringlen=ip6_fmt(ip6str,misc);
+    if (!stralloc_catb(out,ip6str,stringlen)) return 0;
+  }
   else {
     if (!stralloc_cats(out," ")) return 0;
     uint16_unpack_big(misc,&u16);
diff -uNr djbdns-1.05/qlog.c djbdns-1.05-new/qlog.c
--- djbdns-1.05/qlog.c	2001-02-11 16:11:45.000000000 -0500
+++ djbdns-1.05-new/qlog.c	2003-09-16 10:09:36.000000000 -0400
@@ -20,15 +20,15 @@
   put('0' + (c & 7));
 }
 
-void qlog(const char ip[4],uint16 port,const char id[2],const char *q,const char qtype[2],const char *result)
+void qlog(const char ip[16],uint16 port,const char id[2],const char *q,const char qtype[2],const char *result)
 {
   char ch;
   char ch2;
 
-  hex(ip[0]);
-  hex(ip[1]);
-  hex(ip[2]);
-  hex(ip[3]);
+  {
+    int i;
+    for (i=0; i<16; ++i) hex(ip[i]);
+  }
   put(':');
   hex(port >> 8);
   hex(port & 255);
